#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
//#define endl '\n'
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using oset = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

ll INF = 1e10;

struct DSU {
    vi s, p, mx;

    DSU(ll n, vi &a) {
        p.resize(n);
        s.resize(n, 1);
        mx.resize(n);
        for (ll i = 0; i < n; i++) {
            mx[i] = a[i];
        }
        iota(all(p), 0);
    }

    ll leader(ll v) {
        if (v == p[v]) return v;
        return p[v] = leader(p[v]);
    }

    void unite(ll x, ll y) {
        x = leader(x);
        y = leader(y);
        if (x == y) return;
        if (s[y] > s[x]) {
            swap(x, y);
        }
        mx[x] = max(mx[x], mx[y]);
        p[y] = x;
        s[x] += s[y];
    }
};

struct seg_tree {
    vi t, to_push;

    seg_tree(ll n, vi &a) {
        t.resize(4 * n);
        to_push.resize(4 * n, INF);
        build(1, 0, n - 1, a);
    }

    void build(ll v, ll l, ll r, vi &a) {
        if (l == r) {
            t[v] = a[l];
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m + 1, r, a);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    void push(ll v, ll l, ll r) {
        if (to_push[v] != INF) {
            to_push[2 * v] = to_push[v];
            to_push[2 * v + 1] = to_push[v];
            ll m = (l + r) / 2;
            t[2 * v] = (m - l + 1) * to_push[v];
            t[2 * v + 1] = (r - m) * to_push[v];
            to_push[v] = INF;
        }
    }

    void upd(ll v, ll tl, ll tr, ll l, ll r, ll x) {
        if (tl >= l && tr <= r) {
            t[v] = (tr - tl + 1) * x;
            to_push[v] = x;
            return;
        }
        if (tl > r || tr < l) return;
        push(v, tl, tr);
        ll m = (tl + tr) / 2;
        upd(2 * v, tl, m, l, r, x);
        upd(2 * v + 1, m + 1, tr, l, r, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r) {
        if (tl >= l && tr <= r) return t[v];
        if (tl > r || tr < l) return 0;
        ll m = (tl + tr) / 2;
        push(v, tl, tr);
        return get(2 * v, tl, m, l, r) + get(2 * v + 1, m + 1, tr, l, r);
    }
};

void update_left(seg_tree &t, ll ql, ll qr, ll x, ll n) {
    ll l = ql, r = qr + 1;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (t.get(1, 0, n - 1, m, m) <= x) {
            l = m;
        } else {
            r = m;
        }
    }
  //  cout << " upd  " << ql << " " << l << "  " << x << endl;
    if (t.get(1, 0, n - 1, l, l) <= x) {
        t.upd(1, 0, n - 1, ql, l, x);
    }
}

void update_right(seg_tree &t, ll ql, ll qr, ll x, ll n) {
    ll l = ql - 1, r = qr;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (t.get(1, 0, n - 1, m, m) <= x) {
            r = m;
        } else {
            l = m;
        }
    }
    if (t.get(1, 0, n - 1, r, r) <= x) {
        t.upd(1, 0, n - 1, r, qr, x);
    }
}

void solve() {
    ll n;
    cin >> n;
    vi a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    vi k(n - 1);
    for (ll i = 0; i < n - 1; i++) {
        cin >> k[i];
    }
    vi pref(n + 1);
    for (ll i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    DSU dsu(n, a);
    oset s;
    seg_tree t1(n, a);
    seg_tree t2(n, a);
    for (ll i = 0; i < n - 1; i++) {
        ll num = k[i] - 1;
        ll l = 0, r = n;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (mid - s.order_of_key(mid) <= num) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ll id = l;
        ll j = id + 1;
        l = id - dsu.s[dsu.leader(id)] + 1;
        r = id + dsu.s[dsu.leader(id + 1)];
        ll mxl = dsu.mx[dsu.leader(l)], mxr = dsu.mx[dsu.leader(r)];
        dsu.unite(id, j);
        ll l1 = l, r1 = id;
        ll l2 = id + 1, r2 = r;

        update_left(t1, l2, r2, mxl, n);
        update_right(t2, l1, r1, mxr, n);

        // for (ll j = l2; j <= r2; j++) {
        //     if (left[j] > mxl) break;
        //     left[j] = mxl;
        // }
        // for (ll j = r1; j >= l1; j--) {
        //     if (rig[j] > mxr) break;
        //     rig[j] = mxr;
        // }


        ll L = l, R = r + 1;
        while (R - L > 1) {
            ll MID = (L + R) / 2;
            if (t1.get(1, 0, n - 1, MID, MID) <= t2.get(1, 0, n - 1, MID, MID)) {
                L = MID;
            } else {
                R = MID;
            }
        }
        if (t1.get(1, 0, n - 1, L, L) > t2.get(1, 0, n - 1, L, L)) {
            L--;
        }
        ll ans = 0;

        // for (ll j = l; j <= r; j++) {
        //     if (j <= L) {
        //         ans += left[j] - a[j];
        //     } else {
        //         ans += rig[j] - a[j];
        //     }
        // }

        if (L >= l) {
            ans += t1.get(1, 0, n - 1, l, L);
        }
        L++;
        if (L <= r) {
            ans += t2.get(1, 0, n - 1, L, r);
        }
       // cout << L << " " << r << endl;
        ans -= pref[r + 1] - pref[l];
        cout << ans << endl;
        s.insert(id);
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
}
