#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using oset = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

struct DSU {
    vi s, p, l, r, sum;

    DSU(ll n, vi &a) {
        p.resize(n);
        s.resize(n);
        iota(all(p), 0);
        l.resize(n);
        r.resize(n);
        for (ll i = 0; i < n; i++) {
            l[i] = r[i] = sum[i] = a[i];
        }
    }

    ll leader(ll v) {
        if (v == p[v]) return v;
        return p[v] = leader(p[v]);
    }

    void unite(ll x, ll y) {
        x = leader(x);
        y = leader(y);
        if (x == y) return;
        if (s[x] > s[y])
            swap(x, y);
        p[x] = y;
        s[y] += s[x];
        sum[x] += sum[y];
        l[x] = max(l[x], l[y]);
        r[x] = max(r[x], r[y]);
    }
};

void solve() {
    ll n;
    cin >> n;
    vi a(n), left(n), rig(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        left[i] = a[i];
        rig[i] = a[i];
    }
    vi k(n - 1);
    for (ll i = 0; i < n - 1; i++) {
        cin >> k[i];
    }
    if (n <= 1000) {
        vi b(n);
        iota(all(b), 0);
        for (ll i = 0; i < n - 1; i++) {
            ll num = k[i] - 1;
            ll l, r;
            for (ll j = 0; j < n; j++) {
                if (num == b[j]) {
                    l = j;
                    break;
                }
            }
            for (ll j = 0; j < n; j++) {
                if (num + 1 == b[j]) {
                    r = j;
                }
            }
            ll val1 = 0;
            for (ll j = l; j <= r; j++) {
                val1 += min(left[j], rig[j]) - a[j];
            }
            for (ll j = l + 1; j <= r; j++) {
                b[j] = num;
                left[j] = max(left[j - 1], left[j]);
            }
            for (ll j = r - 1; j >= l; j--) {
                rig[j] = max(rig[j], rig[j + 1]);
            }
            for (ll j = r + 1; j < n; j++) {
                b[j]--;
            }
            ll val2 = 0;
            for (ll j = l; j <= r; j++) {
                val2 += min(left[j], rig[j]) - a[j];
            }
            cout << val2 << endl;
        }
    } else {
        DSU dsu(n, a);
        oset s;
        for (ll i = 0; i < n - 1; i++) {
            ll num = k[i] - 1;
            ll l = 0, r = n;
            while (r - l > 1) {
                ll mid = (l + r) / 2;
                if (s.order_of_key(mid) <= num) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            ll id = l;
            ll j = id + 1;
            dsu.unite(id, j);
            ll lead = dsu.leader(id);
            cout << min(dsu.l[lead], dsu.r[lead]) * dsu.s[lead] - dsu.sum[lead] << endl;
            s.insert(id);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
}
